## libtypec 0.5.1

=== debian/changelog ===
libtypec (0.5.1-1) unstable; urgency=low

  * Initial release (Closes: #1023477)

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 11 Jun 2024 16:47:29 +0200

## libtypec 0.5.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16.3)
project(libtypec VERSION 0.5.2 DESCRIPTION "Library to interface with USB Type-C and USB Power Delivery class devices")


# Distributions set arch-specific include dir by patching GNUInstallDirs
include(GNUInstallDirs)

# Saying ${CMAKE_CURRENT_BINARY_DIR}/ here is redundant but more readable
configure_file(libtypec_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/libtypec_config.h)

include(InstallRequiredSystemLibraries)
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSES")
set(CPACK_PACKAGE_VERSION_MAJOR "${PROJECT_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${PROJECT_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${PROJECT_VERSION_PATCH}")
SET(CPACK_SET_DESTDIR "ON")
set(CPACK_PACKAGE_VENDOR "Rajaram Regupathy")
set(CPACK_PACKAGE_CONTACT "rajaram.regupathy@gmail.com")
set(CPACK_RPM_PACKAGE_LICENSE "MIT")
set(CPACK_RPM_PACKAGE_GROUP "Development/Libraries")
set(CPACK_RPM_SPEC_CHANGELOG "${CPACK_RPM_PACKAGE_VERSION}-${CPACK_RPM_PACKAGE_RELEASE}\n  Generated by CPack RPM (Refer:https://github.com/Rajaram-Regupathy/libtypec/releases)")
set(CPACK_SYSTEM_NAME "${CMAKE_SYSTEM_PROCESSOR}")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Rajaram Regupathy")
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_PACKAGE_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/package)
set(CPACK_SOURCE_IGNORE_FILES .git/ build/ bin/ CMakeCache.txt cmake_install.cmake _CPack_Packages/ CMakeFiles/ package/ )
include(CPack)

add_library(libtypec SHARED libtypec.c libtypec_sysfs_ops.c libtypec_dbgfs_ops.c)

target_include_directories(libtypec PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}> $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

option(LIBTYPEC_STRICT_CFLAGS "Compile for strict warnings" ON)
if(LIBTYPEC_STRICT_CFLAGS)
    target_compile_options(libtypec PRIVATE -g -O2 -fstack-protector-strong -Wformat=1 -Werror=format-security -Wdate-time -fasynchronous-unwind-tables -D_FORTIFY_SOURCE=2)
endif()

set_target_properties(libtypec PROPERTIES
	OUTPUT_NAME "typec"
	VERSION ${PROJECT_VERSION}
	SOVERSION ${PROJECT_VERSION_MINOR}
	PUBLIC_HEADER "libtypec.h;${CMAKE_CURRENT_BINARY_DIR}/libtypec_config.h")

add_subdirectory(utils)


install(TARGETS libtypec lstypec typecstatus
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME     DESTINATION bin
    PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

configure_file(
    libtypec.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/libtypec.pc
    @ONLY
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libtypec.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== utils/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16.3)
project(libtypec_utils VERSION 0.5.2)

configure_file(libtypec_utils_config.h.in libtypec_utils_config.h)


add_executable(lstypec lstypec.c names.c)
target_include_directories(lstypec PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(lstypec PUBLIC libtypec udev)

add_executable(typecstatus typecstatus.c names.c)
target_link_libraries(typecstatus PUBLIC libtypec udev)

option(LIBTYPEC_STRICT_CFLAGS "Compile for strict warnings" ON)
if(LIBTYPEC_STRICT_CFLAGS)
    target_compile_options(lstypec PRIVATE -g -O2 -fstack-protector-strong -Wformat=1 -Werror=format-security -Wdate-time -fasynchronous-unwind-tables -D_FORTIFY_SOURCE=2)
    target_compile_options(typecstatus PRIVATE -g -O2 -fstack-protector-strong -Wformat=1 -Werror=format-security -Wdate-time -fasynchronous-unwind-tables -D_FORTIFY_SOURCE=2)
endif()

=== debian/changelog ===
libtypec (0.5.2-1) unstable; urgency=medium

  * New upstream release.

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 29 Jun 2024 14:33:56 +0200

=== debian/control ===
Source: libtypec
Section: utils
Priority: optional
Maintainer: Andrej Shadura <andrewsh@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.16.3~),
 libudev-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/libtypec/libtypec
Vcs-Git: https://salsa.debian.org/debian/libtypec.git
Vcs-Browser: https://salsa.debian.org/debian/libtypec

Package: libtypec5
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: generic USB-C port management library
 libtypec provides a generic interface abstracting all platform
 complexity for efficient userspace USB-C port management.
 .
 The library can also enable development of diagnostic and
 debug tools to debug system issues around USB-C/USB PD topology.

Package: libtypec-dev
Section: libdevel
Architecture: any
Depends:
 libtypec5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: generic USB-C port management library (development files)
 libtypec provides a generic interface abstracting all platform
 complexity for efficient userspace USB-C port management.
 .
 The library can also enable development of diagnostic and
 debug tools to debug system issues around USB-C/USB PD topology.
 .
 This package provides the development needed to build applications using
 the libtypec library.

Package: libtypec-utils
Architecture: any
Depends:
 libtypec5 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: generic USB-C port management library (tools)
 libtypec provides a generic interface abstracting all platform
 complexity for efficient userspace USB-C port management.
 .
 The library can also enable development of diagnostic and
 debug tools to debug system issues around USB-C/USB PD topology.
 .
 This package provides tools using the libtypec library.

## libtypec 0.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.16.3)
-project(libtypec VERSION 0.5.2 DESCRIPTION "Library to interface with USB Type-C and USB Power Delivery class devices")
+project(libtypec VERSION 0.6.0 DESCRIPTION "Library to interface with USB Type-C and USB Power Delivery class devices")
 
 
 # Distributions set arch-specific include dir by patching GNUInstallDirs
@@ -45,7 +45,7 @@
 add_subdirectory(utils)
 
 
-install(TARGETS libtypec lstypec typecstatus
+install(TARGETS libtypec lstypec typecstatus ucsicontrol
     LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
     RUNTIME     DESTINATION bin
     PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

=== utils/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16.3)
project(libtypec_utils VERSION 0.6.0)

configure_file(libtypec_utils_config.h.in libtypec_utils_config.h)

find_package(PkgConfig REQUIRED)
pkg_check_modules(GTK3 REQUIRED gtk+-3.0)

include_directories(${GTK3_INCLUDE_DIRS})
link_directories(${GTK3_LIBRARY_DIRS})
add_definitions(${GTK3_CFLAGS_OTHER})

add_executable(lstypec lstypec.c names.c)
target_include_directories(lstypec PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(lstypec PUBLIC libtypec udev)

add_executable(usbcview usbcview.c names.c)
target_include_directories(usbcview PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(usbcview PUBLIC libtypec udev ${GTK3_LIBRARIES})

add_executable(typecstatus typecstatus.c names.c)
target_link_libraries(typecstatus PUBLIC libtypec udev)

add_executable(ucsicontrol ucsicontrol.c names.c)
target_link_libraries(ucsicontrol PUBLIC libtypec udev)

option(LIBTYPEC_STRICT_CFLAGS "Compile for strict warnings" ON)
if(LIBTYPEC_STRICT_CFLAGS)
    target_compile_options(lstypec PRIVATE -g -O2 -fstack-protector-strong -Wformat=1 -Werror=format-security -Wdate-time -fasynchronous-unwind-tables -D_FORTIFY_SOURCE=2)
    target_compile_options(typecstatus PRIVATE -g -O2 -fstack-protector-strong -Wformat=1 -Werror=format-security -Wdate-time -fasynchronous-unwind-tables -D_FORTIFY_SOURCE=2)
    target_compile_options(ucsicontrol PRIVATE -g -O2 -fstack-protector-strong -Wformat=1 -Werror=format-security -Wdate-time -fasynchronous-unwind-tables -D_FORTIFY_SOURCE=2)
endif()

=== debian/changelog ===
libtypec (0.6.0-4) unstable; urgency=medium

  * Install usbcview into /usr/bin (Closes: #1089989)

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 15 Dec 2024 12:17:40 +0100

libtypec (0.6.0-3) unstable; urgency=medium

  * Actually install usbcview.

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 04 Dec 2024 11:24:39 +0100

libtypec (0.6.0-2) unstable; urgency=medium

  * Add a manpage for ucsicontrol.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 03 Dec 2024 22:38:42 +0100

libtypec (0.6.0-1) unstable; urgency=medium

  * New upstream version.
  * Set upstream metadata fields: Repository.
  * Reset soversion to 0 when building with cmake.
  * Rename the binary library according to the upstream soversion.
  * Depend on libgtk-3-dev as the new utility requires it.
  * Drop unused ${shlibs:Depends}.
  * Add a patch to link libtypec to libudev.
  * Add patches to fix usbcview.c.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 03 Dec 2024 15:24:38 +0100

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  cmake (>= 3.16.3~),
+ libgtk-3-dev,
  libudev-dev,
 Rules-Requires-Root: no
 Standards-Version: 4.6.2
@@ -12,7 +13,7 @@
 Vcs-Git: https://salsa.debian.org/debian/libtypec.git
 Vcs-Browser: https://salsa.debian.org/debian/libtypec
 
-Package: libtypec5
+Package: libtypec0
 Section: libs
 Architecture: any
 Depends:
@@ -29,9 +30,8 @@
 Section: libdevel
 Architecture: any
 Depends:
- libtypec5 (= ${binary:Version}),
+ libtypec0 (= ${binary:Version}),
  ${misc:Depends},
- ${shlibs:Depends},
 Description: generic USB-C port management library (development files)
  libtypec provides a generic interface abstracting all platform
  complexity for efficient userspace USB-C port management.
@@ -45,7 +45,7 @@
 Package: libtypec-utils
 Architecture: any
 Depends:
- libtypec5 (= ${binary:Version}),
+ libtypec0 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Description: generic USB-C port management library (tools)

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

# LIBTYPEC_STRICT_CFLAGS=OFF to disable upstream’s custom build flags
# CMAKE_SKIP_RPATH=PN to prevent build paths from being embedded into the binaries
override_dh_auto_configure:
	dh_auto_configure -- -DLIBTYPEC_STRICT_CFLAGS=OFF -DCMAKE_SKIP_RPATH=ON

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?V?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
             https://github.com/libtypec/libtypec/tags \
             .*/archive/(?:refs/tags/)?(?:@PACKAGE@)?@ANY_VERSION@\.tar\..z
